using System;
using System.Collections.Generic;
using System.Text;
using System.Net.Sockets;
using System.IO;
using assignmentObjects;
using System.Net;

namespace assignmentObjects
{
    public class Connection
    {
        Socket connectionSocket = null;
        //Stream theStream = null;
        List<byte> receivedData = new List<byte>();
        uint totalRead = 0;
        int timesRead = 0;

        public Connection()
        {
        }

        public Connection(Socket theSocket)
        {
            this.connectionSocket = theSocket;
        }

        public delegate void ConnectedHandler();

        public event ConnectedHandler Connected;

        public void OnConnected()
        {
            if(Connected != null){
                Connected();
            }
        }

        public delegate void ReceivedHandler(byte[] data);

        public event ReceivedHandler Received;

        public void OnReceive(byte[] data)
        {
            if(Received != null){
                Received(data);
            }
        }
        
        public void connect(String ipAddress, int port){
            connectionSocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            //connectionSocket.Connect(new System.Net.EndPoint(ipAddress), port);          
            //connectionSocket.Connect(ipAddress, port);
            IPEndPoint iep = new IPEndPoint(IPAddress.Parse(ipAddress), port);
            connectionSocket.BeginConnect(iep, onConnect, connectionSocket);      
        }

        public void onConnect(IAsyncResult theResult)
        {
            
            connectionSocket.EndConnect(theResult);
            OnConnected();
        }
        public Boolean connected()
        {
            return connectionSocket.Connected;
        }

        public void receive()
        {           
            StateObject stateObject = new StateObject();
            stateObject.workSocket = connectionSocket;
            connectionSocket.BeginReceive(stateObject.buffer, 0, stateObject.buffer.Length, SocketFlags.None,
            new AsyncCallback(onReceived), stateObject);
                   
        }

        public void onReceived(IAsyncResult ar)
        {
            /*connectionSocket.EndReceive(theResult);
            byte[] buffer = (byte[])theResult.AsyncState;
            OnReceive(buffer);*/
            StateObject so = (StateObject)ar.AsyncState;
            Socket s = so.workSocket;
            uint read = (uint) s.EndReceive(ar);
            totalRead += read;
            for(uint i = 0; i<read; i++)
            {
                so.sb.Add(so.buffer[i]);
                receivedData.Add(so.buffer[i]);
            }

            if (read == so.buffer.Length)
            {
                
                connectionSocket.BeginReceive(so.buffer, 0, so.buffer.Length, 0,
                                         new AsyncCallback(onReceived), so);
            }
            else
            {
                if (so.sb.Count > 1)
                {
                    byte[] theData = so.sb.ToArray();
                    byte[] otherData = receivedData.ToArray();
                    timesRead++;
                    OnReceive(otherData);
                    receivedData.Clear();
                    totalRead = 0;

                    
                }
                //s.Close();
            }

        }

        public void send(Byte[] theData)
        {
            
            StateObject so2 = new StateObject();
            so2.workSocket = connectionSocket;
            so2.totalSize = theData.Length;
            byte[] buff = theData;
            object theObject = 
            connectionSocket.BeginSend(buff, 0, buff.Length, 0,
                                  new AsyncCallback(onSent), so2);
            
        }

        public void onSent(IAsyncResult theResult)
        {
            connectionSocket.EndSend(theResult);
            StateObject stateObject = (StateObject)theResult.AsyncState;
            Socket aSocket = stateObject.workSocket;
            
        }

        public void registerConnectionHandler(ConnectedHandler theHandler)
        {
            Connected += new ConnectedHandler(theHandler);
        }

        public void registerReceivedHandler(ReceivedHandler theHandler)
        {
            Received += new ReceivedHandler(theHandler);
        }


        public void testController()
        {

        }


        //ublic void send(Reply theReply)
        //{
            //while (connected())
           // {
                
           // }
       // }

    }
}
