using System;
using System.Collections.Generic;
using System.Text;
using System.Net.Sockets;
using System.Net;
using assignmentObjects;
using System.Drawing;
using System.Management;
using System.Diagnostics;
using System.Windows.Forms;

namespace assignmentObjects
{
    public class Controller
    {
        Socket serverSocket;
        Socket theConnection;

        Connection connection;

        //Events and Handlers

         public delegate void ScreenshotHandler();
         event ScreenshotHandler ScreenShotReceived;

         public delegate void UsersReceivedHandler();
         event UsersReceivedHandler UsersReceived;

         public delegate void KeyReceivedHandler();
         event KeyReceivedHandler KeyReceived;

         public delegate void ProcessesReceivedHandler();
         event ProcessesReceivedHandler ProcessesReceived;

        public delegate void DirectoryReceivedHandler();
        public event DirectoryReceivedHandler DirectoryReceived;

        public void OnScreenShotReceived(Bitmap theScreenshot)
        {
            if(ScreenShotReceived != null)
            {
                OnScreenShotReceived(theScreenshot);
            }
            Console.WriteLine("Screenshot Received");
        }

        public void OnUsersReceived(List<string> users)
        {
            if (UsersReceived != null)
            {
                OnUsersReceived(users);
               
            }
            Console.WriteLine("Users Received");
        }

        public void OnKeyReceived(String keypressed)
        {
            if (KeyReceived != null)
            {
                OnKeyReceived(keypressed);
                
            }
            Console.WriteLine("Keypress Received");
        }

        public void OnProcessesReceived(List<string> processes)
        {
            if (ProcessesReceived != null)
            {
                OnProcessesReceived(processes);
                
            }
            Console.WriteLine("Processes Received");
        }

        public void OnDirectoryReceived(TreeNode directory)
        {
            if (DirectoryReceived != null)
            {
                OnDirectoryReceived(directory);
                
            }
            Console.WriteLine("DirectoryReceived Received");
        }

        public void registerScreenshotHandler(ScreenshotHandler theHandler)
        {
            ScreenShotReceived += theHandler;
        }

        public void registerKerReceivedHandler(KeyReceivedHandler theHandler)
        {
            KeyReceived += theHandler;
        }

        public void registerUsersReceivedHandler(UsersReceivedHandler theHandler)
        {
            UsersReceived += theHandler;
        }

        public void registerProcessesReceivedHandler(ProcessesReceivedHandler theHandler)
        {
            ProcessesReceived += theHandler;
        }

        public void registerDirectoryReceivedHandler(DirectoryReceivedHandler theHandler)
        {
            DirectoryReceived += theHandler;
        }

        //end of events of handlers


        public Controller()
        {

        }

        public Controller(Connection theConnection)
        {
            this.connection = theConnection;
            this.connection.registerReceivedHandler(replyReceived);                    
        }

        public void sendCommand(Command theCommand)
        {
            byte[] theData = theCommand.Serialize();
            connection.send(theData);
            receiveReply();
        }

         void receiveReply()
        {
            connection.receive();
        }

        void replyReceived(byte[] theData)
        {
            Reply theReply = new Reply();
            theReply = theReply.DeSerialize(theData);
            if (theReply != null)
            {
                theReply.notify(this);               
                //receiveReply();
            }
            else
            {
                //receiveReply();
            }
        }      
        
    }
}
