using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using System.Runtime.Serialization.Formatters.Binary;
using System.IO;

namespace assignmentObjects
{
    [Serializable]
    public class ListActiveProcessesReply:Reply
    {
        List<string> theProcesses;

        public override void notify(Controller theController)
        {
            if (theProcesses.Count != 0)
            {
                theController.OnProcessesReceived(theProcesses);
            }
        }

        public override Reply DeSerialize(byte[] theData)
        {
            BinaryFormatter bin = new BinaryFormatter();
            MemoryStream mem = new MemoryStream();
            mem.Write(theData, 0, theData.Length);
            mem.Seek(0, 0);
            return (ListActiveProcessesReply)bin.Deserialize(mem);
        }

        public ListActiveProcessesReply(List<string> processes)
        {
            this.theProcesses = processes;
        }

        public List<string> getData()
        {
            return theProcesses;
        }
    }
}
